      subroutine askiter(time,newtime,zpos,newzpos,casvel,iternum,
     +                   newitnum,iunit,iout,ibin,iecho, timetype)

      include 'postconst.h'
      include 'pubfunc.h'

***************** Last revision  4/22/89 *******************************
*-----------------------------------------------------------------------
*
*        Subroutine to input iteration time, position, or number
*
*-----------------------------------------------------------------------
c23456789112345678921234567893123456789412345678951234567896123456789712
c
      double precision time,newtime,zpos,newzpos,casvel
      integer iternum,newitnum,iunit,iout,ibin, iecho
      character timetype*1
      character prompt*(MAXPROMPTLENGTH)
      logical quit

      integer option

      quit = .FALSE.

      do while (.not. quit)
         call readmenu(5, option, iunit, iout)
      
         if (option .eq. 1) then
             timetype = 't'
             write(iecho,200)timetype
             write(prompt, 300)time
             newtime = readdouble(prompt, strlen(prompt), .TRUE.,
     +                         time, iunit, iout)
             write(iecho,*)newtime
             newzpos = newtime*casvel
             quit = .TRUE.
         elseif (option .eq. 2) then
             timetype = 'z'
             write(iecho,200)timetype
             write(prompt,400)zpos
             newzpos = readdouble(prompt, strlen(prompt), .TRUE.,
     +                            zpos, iunit, iout)
             write(iecho,*)newzpos
             newtime = dabs(newzpos / casvel)
             quit = .TRUE.
         elseif (option .eq. 3) then
             timetype = 'n'
             write(iecho,200)timetype
             write(prompt, 500)iternum
             newitnum = readinteger(prompt, strlen(prompt), .TRUE.,
     +                              iternum, iunit, iout)
             write(iecho,220)newitnum
             quit = .TRUE.
         elseif (option .eq. 4) then
             call showiter(ibin, iunit, iout)
         end if

      end do
      return
200   format(1a1)
220   format(i5)
300   format('Please enter the desired time [', E14.5, ']: ')
400   format('Please enter the desired Z-position [', E14.5, ']: ')
500   format('Please enter the desired iteration number [', I8, ']: ')
      end

*-----------------------------------------------------------------------
      subroutine ask_iter(option,time,newtime,zpos,newzpos,casvel,
     +                    iternum,newitnum,iunit,iout,ibin,
     +                    timetype)
*-----------------------------------------------------------------------

      include 'postconst.h'
      include 'pubfunc.h'

      integer option
      double precision time,newtime,zpos,newzpos,casvel
      integer iternum,newitnum,iunit,iout,ibin
      character timetype*1
      character prompt*(MAXPROMPTLENGTH)
      character defaultstr*(MAXSTRINGLENGTH)

      write(defaultstr, 600) time, zpos, iternum

      if (option .eq. 1) then
          timetype = 't'
          write(prompt, 300)
          newtime = read_double(READ_DEFPOSX, READ_DEFPOSY,
     +                          prompt, strlen(prompt), .TRUE.,
     +                          .TRUE., time, '(E14.5)',
     +                          defaultstr)
          newzpos = newtime*casvel
      elseif (option .eq. 2) then
              timetype = 'z'
              write(prompt,400) 
              newzpos = read_double(READ_DEFPOSX, READ_DEFPOSY,
     +                              prompt, strlen(prompt), .TRUE.,
     +                              .TRUE., zpos, '(E14.5)',
     +                              defaultstr)
              newtime = dabs(newzpos / casvel)
      elseif (option .eq. 3) then
             timetype = 'n'
             write(prompt, 500)
             newitnum = read_integer(READ_DEFPOSX, READ_DEFPOSY,
     +                               prompt, strlen(prompt), .TRUE.,
     +                               .TRUE., iternum, defaultstr)
      elseif (option .eq. 4) then
              call message(1)
              call showiter(ibin, iunit, iout)
              call clear_messages()
              write(iout, *) 'Please use the graphics window'
      end if

      if (option .ne. 4) then
       

      end if

      return
300   format('Enter desired time')
400   format('Enter desired Z-position')
500   format('Enter desired iteration number')
600   format('[t=', E14.5, ', z=', E14.5, ', iter=', I4, ']')
      end

