      subroutine conlabl2(autcontval,mancontval,numautcont,nummancont,
     +                    tmax,tmin,imax,imin,nn,icont, uout, contlabl, 
     +                    charlabl,conttype)
*-----------------------------------------------------------------------
*
*        Subroutine to calculate and record contour values
*
*-----------------------------------------------------------------------
c
      include 'postconst.h'

      double precision autcontval(MAXCONTOURS)
      double precision mancontval(MAXCONTOURS)
      double precision tmin, tmax
      integer imin, imax, nn, numautcont, nummancont, icont, uout
      character charlabl(MAXCONTOURS)*1,conttype*1, contlabl*1
      double precision continc
      integer iflag
      integer numcont
      
      integer i
*-----------------------------------------------------------------------
c Automatic contour calculation
        if(conttype.eq.'a')then
           numcont = numautcont
           continc=(tmax-tmin)/dble(numautcont-1)
           write(uout, *)
           write(uout, 150)'Interval between contour values: ', continc
           write(uout, *)
           iflag=0
           write(icont,*)  '  '
           write(icont,*)  '  '
           write(icont,*)  '  '
           do 135 i=1,numautcont
              autcontval(i)=tmin + iflag*continc

              write(icont,133)charlabl(i),autcontval(i)
133           format('Contour value ',a1,' = ',e14.5)
              iflag=iflag+1
135        continue
           write(uout, *)
           call write_contdata(uout, contlabl, charlabl, numcont,
     +                         autcontval)
        endif
*-----------------------------------------------------------------------
c  User-specified contour values
        if(conttype.eq.'v')then
           numcont = nummancont
           write(icont,*)  '  '
           write(icont,*)  '  '
           write(icont,*)  '  '
           do 136 i=1,nummancont
              write(icont,133)charlabl(i),mancontval(i)
136        continue
           call write_contdata(uout, contlabl, charlabl, numcont,
     +                         mancontval)
        endif

        write(icont,132)tmax,imax
        write(icont,134)tmin,imin
132     format('Maximum =',e14.5,' at node ',i3)
134     format('Minimum =',e14.5,' at node ',i3)
         do 137 i=numcont,28
          write(icont,*) '   '
137      continue
      return
150   format(A, F14.5)
      end
