      program convert

      use posttypes
      use glob_vars

      include 'pubfunc.h'
     
      character ifilename*(MAXSTRINGLENGTH)
      character ofilename*(MAXSTRINGLENGTH)

      logical err

      write(6, 100) 
      read(5, 200) ifilename

      write(6, 300)
      read(5, 200) ofilename

      ifilename = ifilename(1:strlen(ifilename)) // '.sol'
      ofilename = ofilename(1:strlen(ofilename)) // '.sol'
 
      open(unit = 15, file = ifilename, form = 'unformatted',
     +     err = 80, status = 'old')
      open(unit = 16, file = ofilename, form = 'unformatted',
     +     err = 85, status = 'unknown')

      write(6, 400)
      read(5, 500) taprn1

      write(6, 600)
      read(5, 500) taprw1

      write(6, 700)
      read(5, 500) rmolng

      err = .FALSE.

      read (15) rtitle
      read (15) mtitle
      read (15) nn
      read (15) nns
      read (15) nbe
      read (15) casvel
      read (15) tsol
      read (15) tliq

      write (16) rtitle
      write (16) mtitle
      write (16) nn
      write (16) nns
      write (16) nbe
      write (16) casvel
      write (16) tsol
      write (16) tliq
      write (16) taprn1
      write (16) taprw1
      write (16) rmolng

      do while (.not. err)
         call binread2(t, ut, vt, sigma, epsln, evp, seff, epefft,
     +                 eeff, epdot, uts, ratio, e0, fa, tle, 
     +                 elastic, eflow, dmgcrt, emod, ctime,
     +                 nn, nns, itnum, err, 15, 6)

         write(6, 800) itnum 

         if (.not. err) then
             call write_iter(t, ut, vt, sigma, epsln, evp, seff, epefft,
     +                     eeff, epdot, uts, ratio, e0, fa, tle, 
     +                     elastic, eflow, dmgcrt, emod, ctime,
     +                     nn, nns, itnum, 16)
         end if
      end do

      write(6, *) 'Done'

      close(15, status = 'keep')
      close(16, status = 'keep')
      goto 90

80    write(6, *) 'Error opening input file'
      goto 90
85    write(6, *) 'Error opening output file'
 
90    stop
100   format('Name of the Input Solution File (without .sol): ', $)
200   format(A)
300   format('Name of the Output Solution File (without .sol): ', $)
400   format('Percentage of Taper in the Narrow Wall: ', $)
500   format(d24.9)
600   format('Percentage of Taper in the Wide Wall: ', $)
700   format('Mold Length: ', $)
800   format('Writing iteration number ', I4)
      end
