*-----------------------------------------------------------------
      subroutine dottedline(xi, yi, xf, yf)
*-----------------------------------------------------------------
*     Plots a dotted line between the specified points.
*
*     Author: Rodrigo A. Marin
*     Date  : March 25 1993
*-----------------------------------------------------------------

      include 'postcom.f'
      include 'pubfunc.h'

      double precision DOTLINE_SPFAC

      parameter (DOTLINE_SPFAC = 1.0/90.0)

c     Space between dashes is 1/90.0 of the length of the window diagonal.

      double precision xi, yi
      double precision xf, yf

      double precision xp, yp

      double precision alpha
      double precision dalpha
      double precision l
      double precision ls

      l = dsqrt((xf - xi)**2 + (yf - yi)**2)

      ls = length_win_diag * DOTLINE_SPFAC

      dalpha = ls / l

      alpha = 0.0

      do while (alpha .le. 1.0)
         xp = xi + alpha * (xf - xi)
         yp = yi + alpha * (yf - yi)

         call line(xp, yp, xp, yp)

         alpha = alpha + dalpha
      end do

      return
      end
