      subroutine meshin2(x,y,node,nbnc,nn,nel,nnodel,nbe,imesh,iout)
c-----------------------------------------------------------------------
c     Read in mesh: nodes, elements, and boundaries
c-----------------------------------------------------------------------
      include 'postconst.h'
      include 'pubfunc.h'

      double precision x(nn),y(nn)
      integer node(3,nel),nbnc(5,nbe),imesh,nn,nel,nnodel,nbe

      integer nel6n
      integer temp

      do 20 j=1,nn
         read(imesh,104,err=100,end=200) inode,x(inode),y(inode)
         x(inode) = x(inode)
         y(inode) = y(inode)
20    continue

      do 22 i=1,nel
22       read(imesh,105,err=300,end=400) ielem,(node(j,ielem),j=1,3)

         if (.not. positive_orientation(x(node(1, i)), y(node(1, i)), 
     +                                  x(node(2, i)), y(node(2, i)),
     +                                  x(node(3, i)), y(node(3, i)))) 
     +   then
             temp = node(1, i)
             node(1, i) = node(3, i)
             node(3, i) = temp
         end if

      if ((nnodel .eq. 6) .or. (nnodel .eq. 7)) then
          nel6n = nel / 4

          i = 1

          do while (i .le. nel6n)
             read(imesh, 106, err = 300, end = 400) ielem
             i = i + 1
          end do
      end if

      do 24 i=1,nbe
24       read(imesh,107,err=500,end=600) inod,(nbnc(j,i),j=1,5)
      return
100   write(iout,*) 'Error on input of mesh nodes'
      stop
200   write(iout,*) 'End on input of mesh nodes'
      stop
300   write(iout,*) 'Error on input of mesh elements -check isp2'
      stop
400   write(iout,*) 'End on input of mesh elements'
      stop
500   write(iout,*) 'Error on input of mesh boundaries'
      stop
600   write(iout,*) 'End on input of mesh boundaries'
      stop
104      format(i5,2f10.6)
105      format(4i5)
106      format(i5)
107      format(6i5)
      end
