      subroutine prst(sigma,sigma2,nn,intgarb)
******************  Last Revision  8/18/87 ********************
*
*         SUBROUTINE PRST
*
**************************************************************
c subroutine to transform x,y,t stresses to
c                         principal stresses and angle
c
c  no subroutines called
c
      implicit double precision (a-h,o-z)
      double precision sigma(4,nn),sigma2(4,nn)
      do 10 n=1,nn
         sx = sigma(1,n)
         sy = sigma(2,n)
         sz=sigma(3,n)
         txy = sigma(4,n)
         con1 = (sx+sy)/2.d0
         con2 = (sx-sy)/2.d0
c************************
c  This tmax is only correct if sy<sz<sx!!!!
c************************
         tmax = dsqrt(con2*con2+txy*txy) 
         sigma2(1,n) = con1 + tmax
         sigma2(2,n) = con1 - tmax
         if (con2 .eq. 0.d0) con2 = 1.d-9
         theta = 28.6479 * atan(txy/con2)
         if ((sy.gt.sx) .and. (txy.ge.0.d0)) theta=theta+90.d0
         if ((sy.gt.sx) .and. (txy.lt.0.d0)) theta=theta-90.d0
         sigma2(4,n) = theta
10       continue
      return
      end 
