               PROGRAM POSTMAIN
**************    Last Revision on  4/22/89 BGT ************************
*
*              POSTMAIN
*
************************************************************************
*23456789112345678921234567893123456789412345678951234567896123456789712
      include 'postcom.f'
      data ibin,imesh,itabl,iecho,icont,iunit,iout /15,16,38,39,19,5,6/
      data xmin,xmax,ymin,ymax /4*0.0/
      data nodnum,elplot,boundplt,nodplot,contlabl,origplot /6*'n'/
      data iternum /0/
      data time /+1.e18/
      data charlabl /'A','B','C','D','E','F','G','H','J','K','L','M',
     + 'N','P','Q','R','S','T','U','V','W','X','Y','Z'/
      data idash /0/
      write(iout,10)
10    format(///,
     + 'Postprocessing results found in local file, binout'/,
     + 'from CONCAST Finite Element Analysis'//,
     + 'Developed by Glen T. Haegele and William R. Storkman, 1987'/,
     + 'and Brian G. Thomas, 1989'//)
c
c Read in the beginning of 'binout' output
c
      open(unit=ibin,file='binout',form='unformatted',status='old')
      call binread1(casvel,tsol,tliq,
     +              rtitle,mtitle,maxn,nn,nns,nbes,ibin,iout)
c
c deciding on interactive input or read in from file 'filname'
c
      open(unit=iecho,file='postecho',status='unknown')
      write(iout,15)
15    format('If a file is to be used as input, type y',/,
     +'    (Interactive input will be used otherwise)')
      read (5,310) decid
310   format(1a1)
      if (decid.eq.'y') then
         iunit = 40
         write(iout,20)
20       format(/,'Type in the name of input ',
     +          'file. (up to 16 characters) ')
         read (5,320) filname
320      format(1a8)
         iout=7
         open(unit=7,file='postout',status='unknown')
         open(unit=40,file=filname,status='old')
      else
         iunit=5
      endif
c
c Read beginning of mesh file
c
      call meshin1(mtitle,isp,isp2,
     + nn,nnodes,nel,nhbw,nbe,icorn,imesh,iunit,iout,iecho)
c
c Deciding on output type
c
800   write(iout,25)
25    format(/,'What kind of output do you desire?',/,
     + '        t  - printout tables (Eg. for use with Cricket Graph)'/,
     + '        c  - contour plot'/,
     + '        d  - plot the displaced shape'/,
     + '        x  - plot stress crosses'/,
     + '        g  - output G & R gradients and velocities'/,
     + '        m  - plot the mesh only'
     + '        q  - quit'/)
      read(iunit,310) decid
      write(iecho,310) decid
c
*23456789112345678921234567893123456789412345678951234567896123456789712
      if (decid .eq. 't') then
c        call postprnt(t,ut,vt,sigma,epsln,evp,seff,epefft,eeff,
c    +       epdot,uts,ratio,e0,fa,tle,tempvar,casvel,sigma2,xplot,
c    +       epsln2,evp2,nn,maxn,nns,iunit,rtitle,mtitle)
      elseif (decid .eq. 'c') then
      open(unit=icont,file='plotcon',status='unknown')
      write(iout,*)
     +   ' Contour label values data will be written to plotcon'
      open(unit=itabl,file='plotits',status='unknown')
      write(iout,*)
     +   ' Iteration data will be written to plotits'
         call conplot
      close(unit=icont,status='keep')
      close(unit=itabl,status='keep') 
      elseif (decid .eq. 'd') then
c        call displot
      elseif (decid .eq. 'x') then
c        call crosplt
      elseif (decid .eq. 'g') then
c       call postgr(t,xplot,xdist,tempvar,tle,sigma,
c    +       casvel,tsol,tliq,
c    +       nn,maxn,nns,iunit,rtitle,mtitle)
      elseif (decid .eq. 'm') then
c        call meshplt
      elseif (decid .ne. 'q') then
         go to 800
      endif
      close(unit=ibin,status='keep')
      if(iunit.eq.40) close(unit=40,status='keep')
      if(iout.eq.7) close(unit=7,status='keep')
      close(unit=iecho,status='keep')
      write(iout,*)' Run complete'
      stop
      end
