      subroutine contur(value,varindx,nn,numel,node,tempvar,
     +                  x,y,xwmin, ywmin, xwmax, ywmax,
     +                  int,yesno,numdecval,keylabel)
*-----------------------------------------------------------------------
c
c     Subroutine to plot contour lines (piece by piece in each element)
c
*-----------------------------------------------------------------------
      implicit double precision (a-h,o-z)

      include 'postconst.h'
      include 'pubfunc.h'

      double precision tempvar(nn),x(nn),y(nn)
      double precision value
      integer varindx
      double precision xwmin, ywmin, xwmax, ywmax
      integer node(3,numel)
      integer numdecval
      character yesno*1, keylabel*1

      logical exponential

      character label*(MAXSTRINGLENGTH)

      intcum=int
      tcon=value

      icount = 0

      label = keylabel

      do 99 i=1,numel
        n1=node(1,i)
        n2=node(2,i)
        n3=node(3,i)
        t1=tempvar(n1)
        t2=tempvar(n2)
        t3=tempvar(n3)
        x1=x(n1)
        x2=x(n2)
        x3=x(n3)
        y1=y(n1)
        y2=y(n2)
        y3=y(n3)
c
      if ((t1 .le. tcon) .and. (t2 .le. tcon) .and. (t3 .gt. tcon)) then
          go to 23
      end if
c
      if ((t1 .ge. tcon) .and. (t2 .ge. tcon) .and. (t3. lt. tcon)) then
          go to 23
      end if
c
      if ((t1 .le. tcon) .and. (t3 .le. tcon) .and. (t2 .gt. tcon)) then
          go to 22
      end if
c
      if ((t1 .ge. tcon) .and. (t3 .ge. tcon) .and. (t2 .lt. tcon)) then
          go to 22
      end if
c
      if ((t2 .le. tcon) .and. (t3 .le. tcon) .and. (t1 .gt. tcon)) then
          go to 24
      end if
c
      if ((t2. ge. tcon) .and. (t3 .ge. tcon) .and. (t1 .lt. tcon)) then
          go to 24
      end if
c
      go to 99
c
22      a12=(t2-tcon)/(t2-t1)
        x12=a12*x1 + (1.0-a12)*x2
        y12=a12*y1 + (1.0-a12)*y2
        a23=(t3-tcon)/(t3-t2)
        x23=a23*x2 + (1.0-a23)*x3
        y23=a23*y2 + (1.0-a23)*y3
        icount=icount+1
        if (yesno.eq.'y') then
          if (icount.gt.intcum) then
             call labplot(x12,y12,label(1:strlen(label)))
             icount=0
           endif
        endif
        call line(x12,y12,x23,y23)
        go to 99
23      a23=(t3-tcon)/(t3-t2)
        x23=a23*x2 + (1.0-a23)*x3
        y23=a23*y2 + (1.0-a23)*y3
        a31=(t1-tcon)/(t1-t3)
        x31=a31*x3 + (1.0-a31)*x1
        y31=a31*y3 + (1.0-a31)*y1
        icount=icount+1
        if (yesno.eq.'y') then
          if (icount.gt.intcum) then
             call labplot(x23,y23,label(1:strlen(label)))
             icount=0
          endif
        endif
        call line(x23,y23,x31,y31)
        go to 99
24      a31=(t1-tcon)/(t1-t3)
        x31=a31*x3 + (1.0-a31)*x1
        y31=a31*y3 + (1.0-a31)*y1
        a12=(t2-tcon)/(t2-t1)
        x12=a12*x1 + (1.0-a12)*x2
        y12=a12*y1 + (1.0-a12)*y2
        icount=icount+1
        if (yesno.eq.'y') then
          if (icount.gt.intcum) then
             call labplot(x31,y31,label(1:strlen(label)))
             icount=0
          endif
        endif
        call line(x31,y31,x12,y12)
99    continue

      return
100   format(F14.<numdecval>)
200   format(E14.<numdecval>)
      end
