      subroutine head
***************** Last revision  4/22/89 *******************************
*
*        Subroutine to assign variable name headers
*
*-----------------------------------------------------------------------
c23456789112345678921234567893123456789412345678951234567896123456789712
c
      use posttypes
      use glob_vars

      header(1)='Nodal Temperature'
      header(2)='U Displacement'
      header(3)='V Displacement'
      header(4)='X-Stress'
      header(5)='Y-Stress'
      header(6)='Z-Stress'
      header(7)='XY-Stress'
      header(8)='X-Strain (total)'
      header(9)='Y-Strain (total)'
      header(10)='Z-Strain (total)'
      header(11)='XY-Strain (total)'
      header(12)='X-Plastic Strain'
      header(13)='Y-Plastic Strain'
      header(14)='Z-Plastic Strain'
      header(15)='XY-Plastic Strain'
      header(16)='Principal Stress 1'
      header(17)='Principal Stress 2'
      header(18)='Principal Stress 3'
      header(19)='Principal Shear Stress'
      header(20)='Principal Strain 1 (total)'
      header(21)='Principal Strain 2 (total)'
      header(22)='Principal Strain 3 (total)'
      header(23)='Principal Shear Strain (total)'
      header(24)='Principal Plastic Strain 1'
      header(25)='Principal Plastic Strain 2'
      header(26)='Principal Plastic Strain 3'
      header(27)='Principal Plastic Shear Strain'
      header(28)='Effective Stress'
      header(29)='Effective Plastic Strain'
      header(30)='Effective Elastic Strain'
      header(31)='Plastic Strain Rate'
      header(32)='Ultimate Tensile Strength'
      header(33)='Stress/UTS'
      header(34)='Thermal Strain'
      header(35)='Fraction Alpha Transformed'
      header(36)='Thermal Linear Expansion'
      header(37)='Hydrostatic Stresses'
      header(38)='Shell Thickness'
      header(39)='Elastic strain X'
      header(40)='Elastic strain Y'
      header(41)='Elastic strain Z'
      header(42)='Elastic strain XY'
      header(43)='Flow strain X'
      header(44)='Flow strain Y'
      header(45)='Flow strain Z'
      header(46)='Flow strain XY'
      header(47)='Damage Criteria 1'
      header(48)='Damage Criteria 2'
      header(49)='Damage Criteria 3'
      header(50)='Damage Criteria 4'
      header(51)='Elastic Modulus(MPa)'
      header(52)='                    '

      tbltitle1(1) = '   Nodal      '
      tbltitle2(1) = ' Temperature  '
      tbltitle1(2) = '     U        '
      tbltitle2(2) = ' Displacement '
      tbltitle1(3) = '     V        '
      tbltitle2(3) = 'Displacement  '
      tbltitle1(4) = '  X_Stress    '
      tbltitle2(4) = '              '
      tbltitle1(5) = '  Y-Stress    '
      tbltitle2(5) = '              '
      tbltitle1(6) = '  Z-Stress    '
      tbltitle2(6) = '              '
      tbltitle1(7) = '  XY-Stress   '
      tbltitle2(7) = '              '
      tbltitle1(8) = '   X-Strain   '
      tbltitle2(8) = '   (total)    '
      tbltitle1(9) = '   Y-Strain   '
      tbltitle2(9) = '   (total)    '
      tbltitle1(10) = '   Z-Strain   '
      tbltitle2(10) = '   (total)    '
      tbltitle1(11) = '   XY-Strain  '
      tbltitle2(11) = '   (total)    '
      tbltitle1(12) = '   X-Plastic  '
      tbltitle2(12) = '    Strain    '
      tbltitle1(13) = '   Y-Plastic  '
      tbltitle2(13) = '    Strain    '
      tbltitle1(14) = '   Z-Plastic  '
      tbltitle2(14) = '    Strain    '
      tbltitle1(15) = '  XY-Plastic  '
      tbltitle2(15) = '    Strain    '
      tbltitle1(16) = '   Principal  '
      tbltitle2(16) = '   Stress 1   '
      tbltitle1(17) = '   Principal  '
      tbltitle2(17) = '   Stress 2   '
      tbltitle1(18) = '   Principal  '
      tbltitle2(18) = '   Stress 3   '
      tbltitle1(19) = '   Principal  '
      tbltitle2(19) = ' Shear Stress '
      tbltitle1(20) = '   Principal  '
      tbltitle2(20) = 'Strain 1 Total'
      tbltitle1(21) = '   Principal  '
      tbltitle2(21) = 'Strain 2 Total'
      tbltitle1(22) = '   Principal  '
      tbltitle2(22) = 'Strain 3 Total'
      tbltitle1(23) = '   Principal  '
      tbltitle2(23) = ' Shear Stress '
      tbltitle1(24) = ' Ppal. Plastic'
      tbltitle2(24) = '   Strain 1   '
      tbltitle1(25) = ' Ppal. Plastic'
      tbltitle2(25) = '   Strain 2   '
      tbltitle1(26) = ' Ppal. Plastic'
      tbltitle2(26) = '   Strain 3   '
      tbltitle1(27) = ' Ppal. Plastic'
      tbltitle2(27) = ' Shear Strain '
      tbltitle1(28) = '  Effective   '
      tbltitle2(28) = '    Stress    '
      tbltitle1(29) = ' Eff. Plastic '
      tbltitle2(29) = '    Strain    '
      tbltitle1(30) = ' Eff. Elastic '
      tbltitle2(30) = '    Strain    '
      tbltitle1(31) = 'Plastic Strain'
      tbltitle2(31) = '     Rate     '
      tbltitle1(32) = ' Ult. Tensile '
      tbltitle2(32) = '   Strength   '
      tbltitle1(33) = ' Stress/UTS   '
      tbltitle2(33) = '              ' 
      tbltitle1(34) = 'Thermal Strain'
      tbltitle2(34) = '              '
      tbltitle1(35) = '  Frac. Alpha '
      tbltitle2(35) = '  Transformed '
      tbltitle1(36) = 'Thermal Linear'
      tbltitle2(36) = '   Expansion  '
      tbltitle1(37) = '  Hydrostatic '
      tbltitle2(37) = '    Stress    '
      tbltitle1(38) = '    Shell     '
      tbltitle2(38) = '  Thickness   '
      tbltitle1(39) = 'Elst Strain X '
      tbltitle2(39) = '              '
      tbltitle1(40) = 'Elst Strain Y '
      tbltitle2(40) = '              '
      tbltitle1(41) = 'Elst Strain Z '
      tbltitle2(41) = '              '
      tbltitle1(42) = 'Elst Strain XY'
      tbltitle2(42) = '              '
      tbltitle1(43) = 'Flow Strain X '
      tbltitle2(43) = '              '
      tbltitle1(44) = 'Flow Strain Y '
      tbltitle2(44) = '              '
      tbltitle1(45) = 'Flow Strain Z '
      tbltitle2(45) = '              '
      tbltitle1(46) = 'Flow Strain XY'
      tbltitle2(46) = '              '
      tbltitle1(47) = 'Damage Crit #1'
      tbltitle2(47) = '              '
      tbltitle1(48) = 'Damage Crit #2'
      tbltitle2(48) = '              '
      tbltitle1(49) = 'Damage Crit #3'
      tbltitle2(49) = '              '
      tbltitle1(50) = 'Damage Crit #4'
      tbltitle2(50) = '              '
      tbltitle1(51) = 'Elastic Mod   '
      tbltitle2(51) = '    (MPa)     '



      return
      end
