      subroutine meshin1(mtitle,isp,isp2,
     + nn,nnodes,nel,nhbw,nbe,icorn,imesh,iunit,iout,iecho)
***************** Last revision  2/06/92 *******************************
*
*            Read in mesh file
*-----------------------------------------------------------------------
c23456789112345678921234567893123456789412345678951234567896123456789712
c This version does NOT read in a second line of special nodes
c
c     Read in mesh file - beginning info
c
      integer isp(10),isp2(16),nnodes,nn,nel,nhbw,nbe,icorn
      integer imesh,iunit,iout,iecho
      character mtitle*80,meshfil*16
c
      write(iout,*)
     + 'Please enter the name of the file containing the mesh'
      read (iunit,fmt='(1a16)') meshfil
      write(iecho,fmt='(1a16)') meshfil
c
      open(unit=imesh,file=meshfil,status='old')
      rewind imesh
c
c        read title of mesh
c
      read(imesh,fmt='(1a80)') mtitle
c
c        read in # of nodes, elements, half bandwidth, and boundaries
c
      read(imesh,102) nnodes,nel,nhbw,nbe
102      format(4i5)
      if (nn .ne. nnodes) then
         write(iout,200) nn,nnodes
200   format(' ** Warning: mesh and binout files NOT compatible ****',/,
     +      i8,' nodes in binout vs. ',i8,' nodes in mesh')
c        stop
         endif
c
c        read in corner node and other special nodes
c
      read(imesh,103) icorn, (isp(i),i=1,10)
103      format(11i5)
c
c        read in special nodes for plotting
c
      read(imesh,104) (isp2(i),i=1,16)
104      format(16i5)
      return
      end
