#ifndef	HF_DEFINED

#if 0
/*---------------------------------------------------------------------------*\
 |									     |
 |	Copyright (c) 1986-1991, 1992 by Ithaca Software.		     |
 |	All rights reserved.						     |
 |	Use of copyright notice does not imply publication or disclosure.    |
 |									     |
 |	THIS SOFTWARE CONTAINS CONFIDENTIAL AND PROPRIETARY INFORMATION	     |
 |	CONSTITUTING VALUABLE TRADE SECRETS OF ITHACA SOFTWARE AND MAY	     |
 |	NOT BE (a) DISCLOSED TO THIRD PARTIES, (b) COPIED IN ANY FORM,	     |
 |	OR (c) USED FOR ANY PURPOSE EXCEPT AS SPECIFICALLY PERMITTED IN	     |
 |	WRITING BY ITHACA SOFTWARE.					     |
 |									     |
\*---------------------------------------------------------------------------*/

/*
 * $Id: generate.c,v 1.7 1992/06/15 18:59:35 norbert Exp $
 */

/*** Generated Mon Nov 30 22:07:32 1992 ***/

/* Hoops Fortran language short-names include file.

   NOTE: this is only required on systems which cannot handle full
   31-character subroutine names with underscores. At present, this
   includes some Unix systems.

   Note that use of this include file required running the C preprocessor
   over the Fortran program. Some Unix systems do this all the time,
   some require a compiler switch, some require that the file type be
   ".F" (capital F) before they'll do it, and some require that you run
   the preprocessor manually:

	/lib/cpp -P program.F >/tmp/program.f; f77 /tmp/program.f


   The name definitions here include blank padding so that the substitution 
   exactly matches the length of original. This makes trailing quoted string 
   continuation lines on source lines with Hoops calls come out right. 
   (Unfortunately, a few C preprocessors trim the blanks!)
    
*/
#endif

#ifdef	SHORT_NAMES

#define HF_ABORT_PROGRAM           FABORT
#define HF_APPEND_MODELLING_MATRIX                     FAPPMM
#define HF_AWAIT_EVENT         FAWAIT
#define HF_BRING_TO_FRONT            FBRING
#define HF_BRING_TO_FRONT_BY_KEY                   FBRGBK
#define HF_CHECK_FOR_EVENTS              FCFEVE
#define HF_CLEAR_DISPLAY           FCLRDS
#define HF_CLOSE_SEGMENT           FCLOSS
#define HF_COMPUTE_SELECTION               FCPSEL
#define HF_COMPUTE_SELECTION_BY_AREA                       FCPSLA
#define HF_COPY_SEGMENT          FCOPYS
#define HF_CREATE_SEGMENT            FCREAS
#define HF_DEFINE_ALIAS          FDALIA
#define HF_DEFINE_COLOR          FDCOLO
#define HF_DEFINE_ERROR_HANDLER                  FDERRH
#define HF_DEFINE_EXIT_HANDLER                 FDEXIH
#define HF_DELETE_BY_KEY           FDELBK
#define HF_DELETE_SEGMENT            FDELET
#define HF_DISABLE_BUTTON_EVENTS                   FDBUTT
#define HF_DISABLE_LOCATION_EVENTS                     FDLOCA
#define HF_DISABLE_SELECTION_EVENTS                      FDSELN
#define HF_DISABLE_STRING_EVENTS                   FDSTRI
#define HF_DISABLE_WAKEUP_EVENTS                   FDWAKE
#define HF_DOLLY_CAMERA          FDOLLY
#define HF_EDIT_PIXEL_ARRAY              FEPIXR
#define HF_EDIT_POLYGON          FEPGON
#define HF_EDIT_POLYLINE           FEPLIN
#define HF_EDIT_TEXT       FETEXT
#define HF_ENABLE_BUTTON_EVENTS                  FEBUTT
#define HF_ENABLE_LOCATION_EVENTS                    FELOCA
#define HF_ENABLE_SELECTION_EVENTS                     FESELN
#define HF_ENABLE_STRING_EVENTS                  FESTRI
#define HF_ENABLE_WAKEUP_EVENTS                  FEWAKE
#define HF_EXIT_PROGRAM          FEXPRG
#define HF_FLUSH_ALL_EVENTS              FFLEVE
#define HF_FLUSH_BY_KEY          FFLKEY
#define HF_FLUSH_SEGMENT           FFLSEG
#define HF_GET_BUTTON        FGBUTT
#define HF_GET_LOCATION          FGLOCA
#define HF_GET_SELECTION           FGSELN
#define HF_GET_STRING        FGSTRI
#define HF_GET_WAKEUP        FGWAKE
#define HF_INCLUDE_SEGMENT             FINCLD
#define HF_INSERT_DISTANT_LIGHT                   FDLIT
#define HF_INSERT_INK          FINK
#define HF_INSERT_LINE          FLINE
#define HF_INSERT_MARKER           FMARKR
#define HF_INSERT_PIXEL_ARRAY                FPIXAR
#define HF_INSERT_PIXEL_ARRAY_BY_REF                       FPIXBR
#define HF_INSERT_POLYGON             FPGON
#define HF_INSERT_POLYLINE             FPLINE
#define HF_INSERT_TEXT         FITEXT
#define HF_KCOPY_SEGMENT           FKCOPS
#define HF_KCREATE_SEGMENT             FKCREA
#define HF_KINCLUDE_SEGMENT              FKINCL
#define HF_KINSERT_DISTANT_LIGHT                   FKDLIT
#define HF_KINSERT_INK          FKINK
#define HF_KINSERT_LINE          FKLINE
#define HF_KINSERT_MARKER            FKMARK
#define HF_KINSERT_PIXEL_ARRAY                 FKPXAR
#define HF_KINSERT_PIXEL_ARRAY_BY_REF                        FKPXBR
#define HF_KINSERT_POLYGON             FKPGON
#define HF_KINSERT_POLYLINE              FKPLIN
#define HF_KINSERT_STRING_CURSOR                   FKSCUR
#define HF_KINSERT_TEXT          FKTEXT
#define HF_KOPEN_SEGMENT           FKOPEN
#define HF_KSTYLE_SEGMENT            FKSTYL
#define HF_MODIFY_COLOR_MAP               FMMAP
#define HF_MODIFY_COLOR_MAP_BY_VALUE                       FMMAPV
#define HF_MOVE_BY_KEY         FMVKEY
#define HF_MOVE_DISTANT_LIGHT                FMDLIT
#define HF_MOVE_PIXEL_ARRAY              FMPXAR
#define HF_MOVE_SEGMENT           FMSEG
#define HF_MOVE_STRING_CURSOR                FMSCUR
#define HF_OPEN_SEGMENT          FOPENS
#define HF_OPEN_SEGMENT_BY_KEY                 FOPENK
#define HF_ORBIT_CAMERA          FORBIT
#define HF_PAN_CAMERA          FPAN
#define HF_PAUSE   FPAUSE
#define HF_PRINT_VERSION           FPVERS
#define HF_QAPPEND_MODELLING_MATRIX                      FQAPMM
#define HF_QDOLLY_CAMERA           FQDOLL
#define HF_QMODIFY_COLOR_MAP               FQMMAP
#define HF_QMODIFY_COLOR_MAP_BY_VALUE                        FQMMPV
#define HF_QORBIT_CAMERA           FQORBI
#define HF_QPAN_CAMERA          FQPAN
#define HF_QROLL_CAMERA          FQROLL
#define HF_QROTATE_OBJECT            FQROTA
#define HF_QROTATE_OBJECT_OFFAXIS                    FQROFF
#define HF_QSCALE_OBJECT           FQSCAL
#define HF_QSET_CAMERA          FQCAM
#define HF_QSET_CAMERA_BY_VOLUME                   FQVOLU
#define HF_QSET_CAMERA_FIELD               FQFILD
#define HF_QSET_CAMERA_POSITION                  FQPOSI
#define HF_QSET_CAMERA_PROJECTION                    FQPROJ
#define HF_QSET_CAMERA_TARGET                FQTARG
#define HF_QSET_CAMERA_UP_VECTOR                    FQUPV
#define HF_QSET_COLOR        FQCOLO
#define HF_QSET_COLOR_BY_INDEX                 FQCIND
#define HF_QSET_COLOR_BY_VALUE                 FQCVAL
#define HF_QSET_COLOR_MAP            FQCMAP
#define HF_QSET_COLOR_MAP_BY_VALUE                     FQCMVL
#define HF_QSET_DRIVER         FQDRIV
#define HF_QSET_DRIVER_OPTIONS                 FQDROP
#define HF_QSET_EDGE_PATTERN               FQEPAT
#define HF_QSET_EDGE_WEIGHT              FQEWEI
#define HF_QSET_FACE_PATTERN               FQFPAT
#define HF_QSET_HANDEDNESS             FQHAND
#define HF_QSET_HEURISTICS             FQHEUR
#define HF_QSET_LINE_PATTERN               FQLPAT
#define HF_QSET_LINE_WEIGHT              FQLWEI
#define HF_QSET_MARKER_SIZE              FQMSIZ
#define HF_QSET_MARKER_SYMBOL                FQMSYM
#define HF_QSET_MODELLING_MATRIX                   FQMMAT
#define HF_QSET_SELECTABILITY                FQSELE
#define HF_QSET_STREAMING_MODE                 FQSTRE
#define HF_QSET_TEXT_ALIGNMENT                 FQALGN
#define HF_QSET_TEXT_FONT            FQFONT
#define HF_QSET_TEXT_PATH            FQPATH
#define HF_QSET_TEXT_SIZE            FQTSIZ
#define HF_QSET_TEXT_SPACING               FQTSPA
#define HF_QSET_USER_OPTIONS               FQUOPT
#define HF_QSET_USER_VALUE             FQUVAL
#define HF_QSET_VISIBILITY             FQVISI
#define HF_QSET_WINDOW         FQWIND
#define HF_QSET_WINDOW_FRAME               FQFRAM
#define HF_QSET_WINDOW_PATTERN                 FQWPAT
#define HF_QSHOW_CAMERA          FQSCAM
#define HF_QSHOW_CAMERA_BY_VOLUME                    FQSVOL
#define HF_QSHOW_CAMERA_FIELD                FQSFLD
#define HF_QSHOW_CAMERA_POSITION                   FQSPOS
#define HF_QSHOW_CAMERA_PROJECTION                     FQSPRJ
#define HF_QSHOW_CAMERA_TARGET                 FQSTGT
#define HF_QSHOW_CAMERA_UP_VECTOR                    FQSUPV
#define HF_QSHOW_COLOR         FQSCOL
#define HF_QSHOW_COLOR_BY_INDEX                  FQSIND
#define HF_QSHOW_COLOR_BY_VALUE                  FQSVAL
#define HF_QSHOW_COLOR_MAP             FQSMAP
#define HF_QSHOW_COLOR_MAP_BY_VALUE                      FQSMPV
#define HF_QSHOW_COLOR_MAP_COUNT                   FQSMPC
#define HF_QSHOW_DRIVER          FQSDRV
#define HF_QSHOW_DRIVER_OPTIONS                  FQSDOP
#define HF_QSHOW_EDGE_PATTERN                FQSEPT
#define HF_QSHOW_EDGE_WEIGHT               FQSEWT
#define HF_QSHOW_FACE_PATTERN                FQSFPT
#define HF_QSHOW_HANDEDNESS              FQSHAN
#define HF_QSHOW_HEURISTICS              FQSHEU
#define HF_QSHOW_LINE_PATTERN                FQSLPT
#define HF_QSHOW_LINE_WEIGHT               FQSLWT
#define HF_QSHOW_MARKER_SIZE               FQSMSZ
#define HF_QSHOW_MARKER_SYMBOL                 FQSSYM
#define HF_QSHOW_MODELLING_MATRIX                    FQSMOD
#define HF_QSHOW_NET_CAMERA              FQNCAM
#define HF_QSHOW_NET_CAMERA_BY_VOLUME                        FQNVOL
#define HF_QSHOW_NET_CAMERA_FIELD                    FQNFLD
#define HF_QSHOW_NET_CAMERA_POSITION                       FQNPOS
#define HF_QSHOW_NET_CAMERA_PROJECTION                         FQNPRJ
#define HF_QSHOW_NET_CAMERA_TARGET                     FQNTGT
#define HF_QSHOW_NET_CAMERA_UP_VECTOR                        FQNUPV
#define HF_QSHOW_NET_COLOR             FQNCOL
#define HF_QSHOW_NET_COLOR_BY_INDEX                      FQNIND
#define HF_QSHOW_NET_COLOR_BY_VALUE                      FQNVAL
#define HF_QSHOW_NET_COLOR_MAP                 FQNMAP
#define HF_QSHOW_NET_COLOR_MAP_BY_VALUE                          FQNMPV
#define HF_QSHOW_NET_COLOR_MAP_COUNT                       FQNMPC
#define HF_QSHOW_NET_DRIVER              FQNDRV
#define HF_QSHOW_NET_DRIVER_OPTIONS                      FQNDOP
#define HF_QSHOW_NET_EDGE_PATTERN                    FQNEPT
#define HF_QSHOW_NET_EDGE_WEIGHT                   FQNEWT
#define HF_QSHOW_NET_FACE_PATTERN                    FQNFPT
#define HF_QSHOW_NET_HANDEDNESS                  FQNHAN
#define HF_QSHOW_NET_HEURISTICS                  FQNHEU
#define HF_QSHOW_NET_LINE_PATTERN                    FQNLPT
#define HF_QSHOW_NET_LINE_WEIGHT                   FQNLWT
#define HF_QSHOW_NET_MARKER_SIZE                   FQNMSZ
#define HF_QSHOW_NET_MARKER_SYMBOL                     FQNSYM
#define HF_QSHOW_NET_MODELLING_MATRIX                        FQNMOD
#define HF_QSHOW_NET_SELECTABILITY                     FQNSEL
#define HF_QSHOW_NET_STREAMING_MODE                      FQNSTR
#define HF_QSHOW_NET_TEXT_ALIGNMENT                      FQNALI
#define HF_QSHOW_NET_TEXT_FONT                 FQNFON
#define HF_QSHOW_NET_TEXT_PATH                 FQNPTH
#define HF_QSHOW_NET_TEXT_SIZE                 FQNTSZ
#define HF_QSHOW_NET_TEXT_SPACING                    FQNSPA
#define HF_QSHOW_NET_USER_OPTIONS                    FQNUOP
#define HF_QSHOW_NET_USER_VALUE                  FQNUVA
#define HF_QSHOW_NET_VISIBILITY                  FQNVIS
#define HF_QSHOW_NET_WINDOW              FQNWIN
#define HF_QSHOW_NET_WINDOW_FRAME                    FQNFRA
#define HF_QSHOW_NET_WINDOW_PATTERN                      FQNWPT
#define HF_QSHOW_ONE_COLOR             FQOCOL
#define HF_QSHOW_ONE_COLOR_BY_INDEX                      FQOIND
#define HF_QSHOW_ONE_COLOR_BY_VALUE                      FQOVAL
#define HF_QSHOW_ONE_COLOR_MAP                 FQOMAP
#define HF_QSHOW_ONE_COLOR_MAP_BY_VALUE                          FQOMPV
#define HF_QSHOW_ONE_DRIVER_OPTION                     FQODOP
#define HF_QSHOW_ONE_HEURISTIC                 FQOHEU
#define HF_QSHOW_ONE_NET_COLOR                 FQONCO
#define HF_QSHOW_ONE_NET_COLOR_BY_INDEX                          FQONIN
#define HF_QSHOW_ONE_NET_COLOR_BY_VALUE                          FQONVA
#define HF_QSHOW_ONE_NET_COLOR_MAP                     FQONCM
#define HF_QSHOW_ONE_NET_COLOR_MAP_BY_V                          FQONMV
#define HF_QSHOW_ONE_NET_DRIVER_OPTION                         FQONDO
#define HF_QSHOW_ONE_NET_HEURISTIC                     FQONHE
#define HF_QSHOW_ONE_NET_SELECTABILITY                         FQONSE
#define HF_QSHOW_ONE_NET_USER_OPTION                       FQONUO
#define HF_QSHOW_ONE_NET_VISIBILITY                      FQONVI
#define HF_QSHOW_ONE_SELECTABILITY                     FQOSEL
#define HF_QSHOW_ONE_USER_OPTION                   FQOUSO
#define HF_QSHOW_ONE_VISIBILITY                  FQOVIS
#define HF_QSHOW_SELECTABILITY                 FQSSEL
#define HF_QSHOW_STREAMING_MODE                  FQSSTR
#define HF_QSHOW_TEXT_ALIGNMENT                  FQSALI
#define HF_QSHOW_TEXT_FONT             FQSFON
#define HF_QSHOW_TEXT_PATH             FQSPTH
#define HF_QSHOW_TEXT_SIZE             FQSTSZ
#define HF_QSHOW_TEXT_SPACING                FQSSPA
#define HF_QSHOW_USER_OPTIONS                FQSUOP
#define HF_QSHOW_USER_VALUE              FQSUVA
#define HF_QSHOW_VISIBILITY              FQSVIS
#define HF_QSHOW_WINDOW          FQSWIN
#define HF_QSHOW_WINDOW_FRAME                FQSFRA
#define HF_QSHOW_WINDOW_PATTERN                  FQSWPT
#define HF_QTRANSLATE_OBJECT               FQTRAN
#define HF_QUNSET_CAMERA           FQUCAM
#define HF_QUNSET_COLOR          FQUCOL
#define HF_QUNSET_COLOR_MAP              FQUMAP
#define HF_QUNSET_DRIVER           FQUDRV
#define HF_QUNSET_DRIVER_OPTIONS                   FQUDOP
#define HF_QUNSET_EDGE_PATTERN                 FQUEPT
#define HF_QUNSET_EDGE_WEIGHT                FQUEWT
#define HF_QUNSET_FACE_PATTERN                 FQUFPT
#define HF_QUNSET_HANDEDNESS               FQUHAN
#define HF_QUNSET_HEURISTICS               FQUHEU
#define HF_QUNSET_LINE_PATTERN                 FQULPT
#define HF_QUNSET_LINE_WEIGHT                FQULWT
#define HF_QUNSET_MARKER_SIZE                FQUMSZ
#define HF_QUNSET_MARKER_SYMBOL                  FQUSYM
#define HF_QUNSET_MODELLING_MATRIX                     FQUMOD
#define HF_QUNSET_SELECTABILITY                  FQUSEL
#define HF_QUNSET_STREAMING_MODE                   FQUSTR
#define HF_QUNSET_TEXT_ALIGNMENT                   FQUALI
#define HF_QUNSET_TEXT_FONT              FQUFON
#define HF_QUNSET_TEXT_PATH              FQUPTH
#define HF_QUNSET_TEXT_SIZE              FQUTSZ
#define HF_QUNSET_TEXT_SPACING                 FQUSPA
#define HF_QUNSET_USER_OPTIONS                 FQUUOP
#define HF_QUNSET_USER_VALUE               FQUUVA
#define HF_QUNSET_VISIBILITY               FQUVIS
#define HF_QUNSET_WINDOW           FQUWIN
#define HF_QUNSET_WINDOW_FRAME                 FQUFRA
#define HF_QUNSET_WINDOW_PATTERN                   FQUWPT
#define HF_QZOOM_CAMERA          FQZOOM
#define HF_RENAME_SEGMENT            FRENAM
#define HF_REPORT_ERROR          FREPER
#define HF_REQUEST_LOCATION              FRLOCA
#define HF_REQUEUE_EVENT           FREQUE
#define HF_RESET_SYSTEM          FRESET
#define HF_RESTART_INK          FRINK
#define HF_ROLL_CAMERA          FROLL
#define HF_ROTATE_OBJECT           FROTAT
#define HF_ROTATE_OBJECT_OFFAXIS                   FROOFF
#define HF_SCALE_OBJECT          FSCALE
#define HF_SCROLL_TEXT         FSCROL
#define HF_SET_CAMERA        FCAMER
#define HF_SET_CAMERA_BY_VOLUME                  FVOLUM
#define HF_SET_CAMERA_FIELD              FFIELD
#define HF_SET_CAMERA_POSITION                 FPOSIT
#define HF_SET_CAMERA_PROJECTION                    FPROJ
#define HF_SET_CAMERA_TARGET               FTARGT
#define HF_SET_CAMERA_UP_VECTOR                  FUPVEC
#define HF_SET_COLOR       FCOLOR
#define HF_SET_COLOR_BY_INDEX                FCINDX
#define HF_SET_COLOR_BY_VALUE                FCVALU
#define HF_SET_COLOR_MAP            FCMAP
#define HF_SET_COLOR_MAP_BY_VALUE                    FCMAPV
#define HF_SET_DRIVER        FDRIVR
#define HF_SET_DRIVER_OPTIONS                FDROPT
#define HF_SET_EDGE_PATTERN              FEDPAT
#define HF_SET_EDGE_WEIGHT             FEDWEI
#define HF_SET_FACE_PATTERN              FFAPAT
#define HF_SET_HANDEDNESS             FHAND
#define HF_SET_HEURISTICS             FHEUR
#define HF_SET_LINE_PATTERN              FLIPAT
#define HF_SET_LINE_WEIGHT             FLIWEI
#define HF_SET_MARKER_SIZE             FMASIZ
#define HF_SET_MARKER_SYMBOL               FMASYM
#define HF_SET_MODELLING_MATRIX                  FMOMAT
#define HF_SET_SELECTABILITY               FSELEC
#define HF_SET_STREAMING_MODE                FSTREA
#define HF_SET_TEXT_ALIGNMENT                FTALGN
#define HF_SET_TEXT_FONT           FTFONT
#define HF_SET_TEXT_PATH           FTPATH
#define HF_SET_TEXT_SIZE           FTSIZE
#define HF_SET_TEXT_SPACING              FTSPAC
#define HF_SET_USER_OPTIONS              FUSOPT
#define HF_SET_USER_VALUE            FUSVAL
#define HF_SET_VISIBILITY            FVISIB
#define HF_SET_WINDOW        FWINDO
#define HF_SET_WINDOW_FRAME              FFRAME
#define HF_SET_WINDOW_PATTERN                FWIPAT
#define HF_SHOW_BUTTON         FSBUTT
#define HF_SHOW_BUTTON_SOURCE                FSBSOU
#define HF_SHOW_CAMERA         FSCAMR
#define HF_SHOW_CAMERA_BY_VOLUME                   FSVOLU
#define HF_SHOW_CAMERA_FIELD               FSFILD
#define HF_SHOW_CAMERA_POSITION                  FSPOSI
#define HF_SHOW_CAMERA_PROJECTION                    FSPROJ
#define HF_SHOW_CAMERA_TARGET                FSTAGT
#define HF_SHOW_CAMERA_UP_VECTOR                    FSUPV
#define HF_SHOW_COLOR        FSCOLR
#define HF_SHOW_COLOR_BY_INDEX                 FSINDX
#define HF_SHOW_COLOR_BY_VALUE                 FSVALU
#define HF_SHOW_COLOR_MAP            FSCMAP
#define HF_SHOW_COLOR_MAP_BY_VALUE                     FSMAPV
#define HF_SHOW_COLOR_MAP_COUNT                  FSMAPC
#define HF_SHOW_DRIVER         FSDRIV
#define HF_SHOW_DRIVER_OPTIONS                 FSDROP
#define HF_SHOW_EDGE_PATTERN               FSEDPT
#define HF_SHOW_EDGE_WEIGHT              FSEDWT
#define HF_SHOW_FACE_PATTERN               FSFAPT
#define HF_SHOW_HANDEDNESS             FSHAND
#define HF_SHOW_HEURISTICS             FSHEUR
#define HF_SHOW_LINE_PATTERN               FSLIPT
#define HF_SHOW_LINE_WEIGHT              FSLIWT
#define HF_SHOW_LOCATION           FSLOCA
#define HF_SHOW_LOCATION_SOURCE                  FSLSOU
#define HF_SHOW_LOCATION_STATUS                  FSLSTA
#define HF_SHOW_MARKER_SIZE              FSMASZ
#define HF_SHOW_MARKER_SYMBOL                FSMSYM
#define HF_SHOW_MODELLING_MATRIX                   FSMODM
#define HF_SHOW_NET_CAMERA             FNCAMR
#define HF_SHOW_NET_CAMERA_BY_VOLUME                       FNVOLU
#define HF_SHOW_NET_CAMERA_FIELD                   FNFILD
#define HF_SHOW_NET_CAMERA_POSITION                      FNPOSI
#define HF_SHOW_NET_CAMERA_PROJECTION                        FNPROJ
#define HF_SHOW_NET_CAMERA_TARGET                    FNTRGT
#define HF_SHOW_NET_CAMERA_UP_VECTOR                       FNUPVC
#define HF_SHOW_NET_COLOR            FNCOLR
#define HF_SHOW_NET_COLOR_BY_INDEX                     FNINDX
#define HF_SHOW_NET_COLOR_BY_VALUE                     FNVALU
#define HF_SHOW_NET_COLOR_MAP                FNCMAP
#define HF_SHOW_NET_COLOR_MAP_BY_VALUE                         FNMAPV
#define HF_SHOW_NET_COLOR_MAP_COUNT                      FNMAPC
#define HF_SHOW_NET_DRIVER             FNDRIV
#define HF_SHOW_NET_DRIVER_OPTIONS                     FNDROP
#define HF_SHOW_NET_EDGE_PATTERN                   FNEDPT
#define HF_SHOW_NET_EDGE_WEIGHT                  FNEDWT
#define HF_SHOW_NET_FACE_PATTERN                   FNFAPT
#define HF_SHOW_NET_HANDEDNESS                 FNHAND
#define HF_SHOW_NET_HEURISTICS                 FNHEUR
#define HF_SHOW_NET_LINE_PATTERN                   FNLIPT
#define HF_SHOW_NET_LINE_WEIGHT                  FNLIWT
#define HF_SHOW_NET_MARKER_SIZE                  FNMASZ
#define HF_SHOW_NET_MARKER_SYMBOL                    FNMSYM
#define HF_SHOW_NET_MODELLING_MATRIX                       FNMODM
#define HF_SHOW_NET_SELECTABILITY                    FNSELE
#define HF_SHOW_NET_STREAMING_MODE                     FNSTRE
#define HF_SHOW_NET_TEXT_ALIGNMENT                     FNALIG
#define HF_SHOW_NET_TEXT_FONT                FNFONT
#define HF_SHOW_NET_TEXT_PATH                FNPATH
#define HF_SHOW_NET_TEXT_SIZE                FNTSIZ
#define HF_SHOW_NET_TEXT_SPACING                   FNSPAC
#define HF_SHOW_NET_USER_OPTIONS                   FNUSOP
#define HF_SHOW_NET_USER_VALUE                 FNUSVA
#define HF_SHOW_NET_VISIBILITY                 FNVISI
#define HF_SHOW_NET_WINDOW             FNWIND
#define HF_SHOW_NET_WINDOW_FRAME                   FNFRAM
#define HF_SHOW_NET_WINDOW_PATTERN                     FNWIPT
#define HF_SHOW_ONE_COLOR            FOCOLR
#define HF_SHOW_ONE_COLOR_BY_INDEX                     FOINDX
#define HF_SHOW_ONE_COLOR_BY_VALUE                      FOVAL
#define HF_SHOW_ONE_COLOR_MAP                FOMAPU
#define HF_SHOW_ONE_COLOR_MAP_BY_VALUE                         FOMPVA
#define HF_SHOW_ONE_DRIVER_OPTION                    FODROP
#define HF_SHOW_ONE_HEURISTIC                FOHEUR
#define HF_SHOW_ONE_NET_COLOR                FONCOL
#define HF_SHOW_ONE_NET_COLOR_BY_INDEX                         FONIND
#define HF_SHOW_ONE_NET_COLOR_BY_VALUE                         FONVAL
#define HF_SHOW_ONE_NET_COLOR_MAP                    FONMAP
#define HF_SHOW_ONE_NET_COLOR_MAP_BY_V                         FONMAV
#define HF_SHOW_ONE_NET_DRIVER_OPTION                        FONDOP
#define HF_SHOW_ONE_NET_HEURISTIC                    FONHEU
#define HF_SHOW_ONE_NET_SELECTABILITY                        FONSEL
#define HF_SHOW_ONE_NET_USER_OPTION                      FONUOP
#define HF_SHOW_ONE_NET_VISIBILITY                     FONVIS
#define HF_SHOW_ONE_SELECTABILITY                    FOSELE
#define HF_SHOW_ONE_USER_OPTION                  FOUSOP
#define HF_SHOW_ONE_VISIBILITY                 FOVISI
#define HF_SHOW_SELECTABILITY                FSSELE
#define HF_SHOW_SELECTION            FSSELN
#define HF_SHOW_SELECTION_ITEM                 FSSITM
#define HF_SHOW_SELECTION_LOCATION                     FSSLOC
#define HF_SHOW_SELECTION_PATHNAME                     FSSPTH
#define HF_SHOW_SELECTION_SOURCE                   FSSELS
#define HF_SHOW_STREAMING_MODE                 FSSTRE
#define HF_SHOW_STRING         FSSTRI
#define HF_SHOW_STRING_SOURCE                FSSTRS
#define HF_SHOW_TEXT_ALIGNMENT                 FSALIN
#define HF_SHOW_TEXT_FONT            FSFONT
#define HF_SHOW_TEXT_PATH            FSPATH
#define HF_SHOW_TEXT_SIZE            FSTSIZ
#define HF_SHOW_TEXT_SPACING               FSSPAC
#define HF_SHOW_TIME       FSTIME
#define HF_SHOW_USER_OPTIONS               FSUSOP
#define HF_SHOW_USER_VALUE             FSUSVA
#define HF_SHOW_VISIBILITY             FSVISI
#define HF_SHOW_WAKEUP         FSWAKE
#define HF_SHOW_WINDOW         FSWIND
#define HF_SHOW_WINDOW_FRAME               FSFRAM
#define HF_SHOW_WINDOW_PATTERN                 FSWIPT
#define HF_STYLE_SEGMENT           FSTYLE
#define HF_TRANSLATE_OBJECT              FTRANS
#define HF_UNDEFINE_ALIAS            FUALIA
#define HF_UNDEFINE_COLOR            FUCOLO
#define HF_UNDEFINE_ERROR_HANDLER                    FUERRH
#define HF_UNDEFINE_EXIT_HANDLER                   FUEXIH
#define HF_UNSET_CAMERA          FUCAME
#define HF_UNSET_COLOR         FUCOLR
#define HF_UNSET_COLOR_MAP             FUCMAP
#define HF_UNSET_DRIVER          FUDRIV
#define HF_UNSET_DRIVER_OPTIONS                  FUDROP
#define HF_UNSET_EDGE_PATTERN                FUEDPT
#define HF_UNSET_EDGE_WEIGHT               FUEDWT
#define HF_UNSET_FACE_PATTERN                FUFAPT
#define HF_UNSET_HANDEDNESS              FUHAND
#define HF_UNSET_HEURISTICS              FUHEUR
#define HF_UNSET_LINE_PATTERN                FULIPT
#define HF_UNSET_LINE_WEIGHT               FULIWT
#define HF_UNSET_MARKER_SIZE               FUMASZ
#define HF_UNSET_MARKER_SYMBOL                 FUMSYM
#define HF_UNSET_MODELLING_MATRIX                    FUMODM
#define HF_UNSET_SELECTABILITY                 FUSELE
#define HF_UNSET_STREAMING_MODE                  FUSTRE
#define HF_UNSET_TEXT_ALIGNMENT                  FUALIN
#define HF_UNSET_TEXT_FONT             FUFONT
#define HF_UNSET_TEXT_PATH             FUPATH
#define HF_UNSET_TEXT_SIZE             FUTSIZ
#define HF_UNSET_TEXT_SPACING                FUSPAC
#define HF_UNSET_USER_OPTIONS                FUUSOP
#define HF_UNSET_USER_VALUE              FUUSVA
#define HF_UNSET_VISIBILITY              FUVISI
#define HF_UNSET_WINDOW          FUWIND
#define HF_UNSET_WINDOW_FRAME                FUFRAM
#define HF_UNSET_WINDOW_PATTERN                  FUWIPT
#define HF_UPDATE_DISPLAY            FUPDAT
#define HF_ZOOM_CAMERA          FZOOM
#define HF_BEGIN_ALIAS_SEARCH                FBALIS
#define HF_BEGIN_COLOR_NAME_SEARCH                     FBCNMS
#define HF_BEGIN_CONTENTS_SEARCH                   FBCONS
#define HF_BEGIN_OPEN_SEGMENT_SEARCH                       FBOSGS
#define HF_BEGIN_SEGMENT_SEARCH                  FBSEGS
#define HF_DEFINE_COLOR_NAME               FDCOLN
#define HF_END_ALIAS_SEARCH              FEALIS
#define HF_END_COLOR_NAME_SEARCH                   FECNMS
#define HF_END_CONTENTS_SEARCH                 FECONS
#define HF_END_OPEN_SEGMENT_SEARCH                     FEOSGS
#define HF_END_SEGMENT_SEARCH                FESEGS
#define HF_FIND_ALIAS        FFALIA
#define HF_FIND_COLOR_NAME             FFCNAM
#define HF_FIND_CONTENTS            FFCON
#define HF_FIND_OPEN_SEGMENT               FFOSEG
#define HF_FIND_RELATED_SELECTION                    FFRSEL
#define HF_FIND_SEGMENT           FFSEG
#define HF_KSHOW_OWNER_BY_KEY                FKSOWK
#define HF_PARSE_STRING          FPARSE
#define HF_QUEUE_BUTTON_EVENT                FQUBUT
#define HF_QUEUE_LOCATION_EVENT                  FQULOC
#define HF_QUEUE_STRING_EVENT                FQUSTV
#define HF_QUEUE_WAKEUP_EVENT                FQUWAK
#define HF_QUEUE_SPECIAL_EVENT                 FQSPEC
#define HF_SHOW_ALIAS        FSALIA
#define HF_SHOW_ALIAS_COUNT              FSALIC
#define HF_SHOW_COLOR_NAME_COUNT                   FSCNMC
#define HF_SHOW_COLOR_NAME             FSCNAM
#define HF_SHOW_CONTENTS_COUNT                 FSCONC
#define HF_SHOW_DISTANT_LIGHT                FSHDLT
#define HF_SHOW_ENVIRONMENT              FSHENV
#define HF_SHOW_INCLUDE_SEGMENT                  FSHINC
#define HF_SHOW_KEY_TYPE           FSHKEY
#define HF_SHOW_LINE       FSHLIN
#define HF_SHOW_MARKER         FSHMRK
#define HF_SHOW_MEMORY_USAGE               FSHMEM
#define HF_SHOW_OPEN_SEGMENT_COUNT                     FSOSGC
#define HF_SHOW_OWNER        FSOWNR
#define HF_SHOW_OWNER_BY_KEY               FSOWNK
#define HF_SHOW_PARTIAL_PIXEL_ARRAY                      FSPPIX
#define HF_SHOW_PARTIAL_POLYGON                  FSPPGN
#define HF_SHOW_PARTIAL_POLYLINE                   FSPPLN
#define HF_SHOW_PATHNAME_EXPANSION                     FSHPEX
#define HF_SHOW_PIXEL_ARRAY              FSHPIX
#define HF_SHOW_PIXEL_ARRAY_SIZE                   FSHPXS
#define HF_SHOW_POLYGON          FSHPGN
#define HF_SHOW_POLYGON_COUNT                FSHPGC
#define HF_SHOW_POLYLINE           FSHPLN
#define HF_SHOW_POLYLINE_COUNT                 FSHPLC
#define HF_SHOW_SEGMENT          FSHSEG
#define HF_SHOW_SEGMENT_COUNT                FSHSGC
#define HF_SHOW_SPECIAL_EVENT                FSSPEC
#define HF_SHOW_STYLE_SEGMENT                FSHSTY
#define HF_SHOW_TEXT       FSHTXT
#define HF_SHOW_TEXT_LENGTH              FSHTXL
#define HF_UNDEFINE_COLOR_NAME                 FUCOLN
#define HF_DEFINE_SYSTEM_OPTIONS                   FDSYOP
#define HF_QSET_METAFILE           FQMETA
#define HF_QSHOW_METAFILE            FQSMET
#define HF_QSHOW_NET_METAFILE                FQNMET
#define HF_QSHOW_ONE_METAFILE                FQOMET
#define HF_QSHOW_ONE_NET_METAFILE                    FQONME
#define HF_QUNSET_METAFILE             FQUMET
#define HF_SET_METAFILE          FMETAF
#define HF_SHOW_DEVICE_INFO              FSHDEV
#define HF_SHOW_METAFILE           FSMETA
#define HF_SHOW_NET_METAFILE               FNMETA
#define HF_SHOW_ONE_METAFILE               FOMETA
#define HF_SHOW_ONE_NET_METAFILE                   FONMET
#define HF_SHOW_ONE_SYSTEM_OPTION                    FSOSOP
#define HF_SHOW_SYSTEM_OPTIONS                 FSSYOP
#define HF_UNSET_METAFILE            FUMETA
#define HF_QSHOW_ONE_TEXT_FONT                 FQOFON
#define HF_QSHOW_ONE_NET_TEXT_FONT                     FQONFO
#define HF_SHOW_ONE_TEXT_FONT                FOFONT
#define HF_SHOW_ONE_NET_TEXT_FONT                    FONFON
#define HF_SHOW_EXISTENCE            FSXIST
#define HF_QSHOW_EXISTENCE             FQSXIS
#define HF_QINSERT_DISTANT_LIGHT                   FQDLIT
#define HF_QINSERT_INK          FQINK
#define HF_QINSERT_LINE          FQLINE
#define HF_QINSERT_MARKER            FQMRKR
#define HF_QINSERT_PIXEL_ARRAY                 FQPIXR
#define HF_QINSERT_PIXEL_ARRAY_BY_REF                        FQPIXB
#define HF_QINSERT_POLYGON             FQPGON
#define HF_QINSERT_POLYLINE              FQPLIN
#define HF_QINSERT_TEXT          FQITXT
#define HF_QKINSERT_DISTANT_LIGHT                    FQKDLT
#define HF_QKINSERT_INK          FQKINK
#define HF_QKINSERT_LINE           FQKLIN
#define HF_QKINSERT_MARKER             FQKMRK
#define HF_QKINSERT_PIXEL_ARRAY                  FQKPXR
#define HF_QKINSERT_PIXEL_ARRAY_BY_REF                         FQKPXB
#define HF_QKINSERT_POLYGON              FQKPGN
#define HF_QKINSERT_POLYLINE               FQKPLN
#define HF_QKINSERT_TEXT           FQKTXT
#define HF_QRESTART_INK          FQRINK
#define HF_COMPUTE_COLOR           FCCOLR
#define HF_COMPUTE_COLOR_BY_VALUE                    FCCLRB
#define HF_BEGIN_FONT_SEARCH               FBFONS
#define HF_SHOW_FONT_COUNT             FSFONC
#define HF_FIND_FONT       FFFONT
#define HF_END_FONT_SEARCH             FEFONS
#define HF_SHOW_FONT_INFO            FSHFON
#define HF_COMPUTE_TEXT_EXTENT                 FCOMTX
#define HF_COMPUTE_TEXT_EXTENT_BY_KEY                        FCMTXK
#define HF_COMPUTE_COORDINATES                 FCCOOR
#define HF_COMPUTE_CROSS_PRODUCT                   FCCRPR
#define HF_COMPUTE_DOT_PRODUCT                 FCDTPR
#define HF_COMPUTE_VECTOR_LENGTH                   FCVCLN
#define HF_COMPUTE_MATRIX_PRODUCT                    FCMTPR
#define HF_COMPUTE_MATRIX_ADJOINT                    FCMTAD
#define HF_COMPUTE_MATRIX_DETERMINANT                        FCMTDT
#define HF_COMPUTE_MATRIX_INVERSE                    FCMTIV
#define HF_COMPUTE_NORMALIZED_MATRIX                       FCNOMT
#define HF_COMPUTE_NORMALIZED_VECTOR                       FCNOVC
#define HF_COMPUTE_IDENTITY_MATRIX                     FCIDNT
#define HF_COMPUTE_SCALE_MATRIX                  FCSCAL
#define HF_COMPUTE_TRANSLATION_MATRIX                        FCTRNS
#define HF_COMPUTE_ROTATION_MATRIX                     FCROTA
#define HF_COMPUTE_OFFAXIS_ROTATION                      FCOARO
#define HF_COMPUTE_OFFCENTER_ROTATION                        FCOCRO
#define HF_COMPUTE_POLYGON_NORMAL                    FCPLYN
#define HF_COMPUTE_POLYGON_PLANE                   FCPLYP
#define HF_COMPUTE_TRANSFORMED_PLANE                       FCTPLN
#define HF_COMPUTE_TRANSFORMED_POINTS                        FCTPTS
#define HF_INSERT_CIRCLE           FICRCL
#define HF_INSERT_CIRCULAR_ARC                 FICARC
#define HF_INSERT_ELLIPSE            FIELPS
#define HF_INSERT_ELLIPTICAL_ARC                   FIEARC
#define HF_KINSERT_CIRCLE            FKCRCL
#define HF_KINSERT_CIRCULAR_ARC                  FKCARC
#define HF_KINSERT_ELLIPSE             FKELPS
#define HF_KINSERT_ELLIPTICAL_ARC                    FKEARC
#define HF_QINSERT_CIRCLE            FQCRCL
#define HF_QINSERT_CIRCULAR_ARC                  FQCARC
#define HF_QINSERT_ELLIPSE             FQELPS
#define HF_QINSERT_ELLIPTICAL_ARC                    FQEARC
#define HF_QKINSERT_CIRCLE             FQKCRC
#define HF_QKINSERT_CIRCULAR_ARC                   FQKCAR
#define HF_QKINSERT_ELLIPSE              FQKELL
#define HF_QKINSERT_ELLIPTICAL_ARC                     FQKELA
#define HF_SHOW_CIRCLE         FSCRCL
#define HF_SHOW_CIRCULAR_ARC               FSCARC
#define HF_SHOW_ELLIPSE          FSELPS
#define HF_SHOW_ELLIPTICAL_ARC                 FSEARC
#define HF_QSET_COLOR_BY_FINDEX                  FQCFIX
#define HF_SET_COLOR_BY_FINDEX                 FCFIDX
#define HF_SET_NORMAL        FSNORM
#define HF_UNSET_NORMAL          FUNORM
#define HF_SHOW_NORMAL         FSHNRM
#define HF_SHOW_NET_NORMAL             FSHNNM
#define HF_MSET_VERTEX_NORMALS                 FMVNRM
#define HF_MSET_VERTEX_COLORS_BY_FINDEX                          FMVCBF
#define HF_MSET_VERTEX_COLORS_BY_VALUE                         FMVCBV
#define HF_QSET_RENDERING_OPTIONS                    FQRROP
#define HF_QSHOW_RENDERING_OPTIONS                     FQSROP
#define HF_QSHOW_NET_RENDERING_OPTIONS                         FQNROP
#define HF_QSHOW_ONE_RENDERING_OPTION                        FQOROP
#define HF_QSHOW_ONE_NET_RENDERING_OPTI                          FQONRO
#define HF_QUNSET_RENDERING_OPTIONS                      FQUROP
#define HF_SET_RENDERING_OPTIONS                   FRROPT
#define HF_SHOW_RENDERING_OPTIONS                    FSRROP
#define HF_SHOW_NET_RENDERING_OPTIONS                        FNRROP
#define HF_SHOW_ONE_RENDERING_OPTION                       FORROP
#define HF_SHOW_ONE_NET_RENDERING_OPTIO                          FONROP
#define HF_UNSET_RENDERING_OPTIONS                     FURROP
#define HF_COMPUTE_CONVEX_HULL                 FCCHUL
#define HF_COMPUTE_TRANSFORM               FCXFRM
#define HF_EDIT_MESH       FEMESH
#define HF_EDIT_SHELL_FACES              FESFAC
#define HF_EDIT_SHELL_POINTS               FESPOI
#define HF_INSERT_MESH         FIMESH
#define HF_KINSERT_MESH          FKMESH
#define HF_QINSERT_MESH          FQMESH
#define HF_QKINSERT_MESH           FQKMSH
#define HF_INSERT_MESH_BY_REF                FIMESR
#define HF_KINSERT_MESH_BY_REF                 FKMESR
#define HF_QINSERT_MESH_BY_REF                 FQMESR
#define HF_QKINSERT_MESH_BY_REF                  FQKMSR
#define HF_INSERT_SHELL          FISHEL
#define HF_KINSERT_SHELL           FKSHEL
#define HF_QINSERT_SHELL           FQSHEL
#define HF_QKINSERT_SHELL            FQKSHL
#define HF_INSERT_SHELL_BY_REF                 FISHER
#define HF_KINSERT_SHELL_BY_REF                  FKSHER
#define HF_QINSERT_SHELL_BY_REF                  FQSHER
#define HF_QKINSERT_SHELL_BY_REF                   FQKSHR
#define HF_SHOW_MESH       FSHMSH
#define HF_SHOW_MESH_SIZE            FSHMSS
#define HF_SHOW_SHELL        FSHSHL
#define HF_SHOW_SHELL_SIZE             FSHSHS
#define HF_FLUSH_ATTRIBUTES              FFLATR
#define HF_FLUSH_CONTENTS            FFLCNT
#define HF_FLUSH_GEOMETRY            FFLGEO
#define HF_OPEN_EDGE       FOPEDG
#define HF_OPEN_VERTEX         FOPVTX
#define HF_OPEN_FACE       FOPFAC
#define HF_OPEN_GEOMETRY           FOPGEO
#define HF_CLOSE_EDGE        FCLEDG
#define HF_CLOSE_VERTEX          FCLVTX
#define HF_CLOSE_FACE        FCLFAC
#define HF_CLOSE_GEOMETRY            FCLGEO
#define HF_RENUMBER_KEY          FRENKY
#define HF_SHOW_SELECTION_ELEMENT                    FSELEL
#define HF_MOVE_TEXT       FMOVTX
#define HF_SHOW_STRING_CURSOR                FSHCUR
#define HF_QUNSET_ONE_DRIVER_OPTION                      FQUODO
#define HF_QUNSET_ONE_HEURISTIC                  FQUOHE
#define HF_QUNSET_ONE_METAFILE                 FQUOMF
#define HF_QUNSET_ONE_COLOR              FQUOCO
#define HF_QUNSET_ONE_RENDERING_OPTION                         FQUORO
#define HF_QUNSET_ONE_SELECTABILITY                      FQUOSE
#define HF_QUNSET_ONE_TEXT_FONT                  FQUOTF
#define HF_QUNSET_ONE_USER_OPTION                    FQUOUO
#define HF_QUNSET_ONE_VISIBILITY                   FQUOVI
#define HF_UNSET_ONE_DRIVER_OPTION                     FUNODO
#define HF_UNSET_ONE_HEURISTIC                 FUNOHE
#define HF_UNSET_ONE_METAFILE                FUNOMF
#define HF_UNSET_ONE_COLOR             FUNOCO
#define HF_UNSET_ONE_RENDERING_OPTION                        FUNORO
#define HF_UNSET_ONE_SELECTABILITY                     FUNOSE
#define HF_UNSET_ONE_TEXT_FONT                 FUNOTF
#define HF_UNSET_ONE_USER_OPTION                   FUNOUO
#define HF_UNSET_ONE_VISIBILITY                  FUNOVI
#define HF_READ_METAFILE           FRMETA
#define HF_WRITE_METAFILE            FWMETA
#define HF_SHOW_SELECTION_POSITION                     FSELPO
#define HF_COMPUTE_TEXT_FROM_TEXT16                      FCTT16
#define HF_COMPUTE_TEXT16_FROM_TEXT                      FCT16T
#define HF_COMPUTE_SELECTION_BY_VOLUME                         FCPSLV
#define HF_COMPUTE_TEXT_EXTENT_WITH_ENC                          FCXENC
#define HF_GET_STRING_WITH_ENCODING                      FGSENC
#define HF_INSERT_TEXT_WITH_ENCODING                       FITENC
#define HF_QINSERT_TEXT_WITH_ENCODING                        FQTENC
#define HF_KINSERT_TEXT_WITH_ENCODING                        FKTENC
#define HF_QKINSERT_TEXT_WITH_ENCODING                         FQKENC
#define HF_SHOW_EXISTENCE_BY_KEY                   FSEXBK
#define HF_SHOW_TEXT_COUNT             FSHTXC
#define HF_SHOW_TEXT_ENCODING                FSHTXE
#define HF_SHOW_TEXT_WITH_ENCODING                     FSHTWE
#define HF_SHOW_STRING_COUNT               FSHSTC
#define HF_SHOW_STRING_LENGTH                FSHSTL
#define HF_SHOW_STRING_WITH_ENCODING                       FSHSWE
#define HF_INSERT_GRID         FIGRID
#define HF_KINSERT_GRID          FKGRID
#define HF_QINSERT_GRID          FQGRID
#define HF_QKINSERT_GRID           FQKGRD
#define HF_SHOW_GRID       FSHGRD
#define HF_SHOW_SELECTION_KEYS                  FSELK
#define HF_SHOW_SELECTION_KEYS_COUNT                       FSELKC
#define HF_QUEUE_RELATED_SELECTION                     FQRSEL
#define HF_QUEUE_SELECTION_EVENT                   FQUSEV
#define HF_MARK_AS_UPDATED             FKMASU
#define HF_MARK_AS_REFRESH_NEEDED                    FKMASR
#define HF_INSERT_LOCAL_LIGHT                FILLIT
#define HF_KINSERT_LOCAL_LIGHT                 FKLLIT
#define HF_QINSERT_LOCAL_LIGHT                 FQLLIT
#define HF_QKINSERT_LOCAL_LIGHT                  FQKLLT
#define HF_INSERT_SPOT_LIGHT               FISLIT
#define HF_KINSERT_SPOT_LIGHT                FKSLIT
#define HF_QINSERT_SPOT_LIGHT                FQSLIT
#define HF_QKINSERT_SPOT_LIGHT                 FQKSLT
#define HF_INSERT_AREA_LIGHT               FIALIT
#define HF_KINSERT_AREA_LIGHT                FKALIT
#define HF_QINSERT_AREA_LIGHT                FQALIT
#define HF_QKINSERT_AREA_LIGHT                 FQKALT
#define HF_SHOW_LOCAL_LIGHT              FSHLLT
#define HF_SHOW_SPOT_LIGHT             FSHSLT
#define HF_SHOW_AREA_LIGHT             FSHALT
#define HF_SHOW_AREA_LIGHT_COUNT                   FSHALC
#define HF_INSERT_IMAGE          FIMAGE
#define HF_KINSERT_IMAGE           FKIMAG
#define HF_QINSERT_IMAGE           FQIMAG
#define HF_QKINSERT_IMAGE            FQKIMG
#define HF_INSERT_IMAGE_BY_REF                 FIMGBR
#define HF_KINSERT_IMAGE_BY_REF                  FKMGBR
#define HF_QINSERT_IMAGE_BY_REF                  FQMGBR
#define HF_QKINSERT_IMAGE_BY_REF                   FQKMGB
#define HF_EDIT_IMAGE        FEIMAG
#define HF_MOVE_IMAGE        FMIMAG
#define HF_SHOW_IMAGE        FSHIMG
#define HF_SHOW_PARTIAL_IMAGE                FSPIMG
#define HF_SHOW_IMAGE_SIZE             FSHMGS
#define HF_MOVE_LIGHT_POSITION                 FMLITP
#define HF_MOVE_LIGHT_TARGET               FMLITT
#define HF_SHOW_EVENT        FSHOEV
#define HF_SHOW_PARTIAL_SHELL                FSHPSH
#define HF_SHOW_PARTIAL_SHELL_SIZE                     FSHPSS
#define HF_DEFINE_CALLBACK_NAME                  FDCBNA
#define HF_UNDEFINE_CALLBACK_NAME                    FUCBNA
#define HF_BEGIN_CALLBACK_NAME_SEARCH                        FBCBNS
#define HF_END_CALLBACK_NAME_SEARCH                      FECBNS
#define HF_FIND_CALLBACK_NAME                FFCBNA
#define HF_SHOW_CALLBACK_NAME                FSCBNA
#define HF_SHOW_CALLBACK_NAME_COUNT                      FSCBNC
#define HF_QSET_CALLBACK           FQCBAK
#define HF_QSHOW_CALLBACK            FQSCBK
#define HF_QSHOW_NET_CALLBACK                FQNCBK
#define HF_QSHOW_ONE_CALLBACK                FQOCBK
#define HF_QSHOW_ONE_NET_CALLBACK                    FQONCB
#define HF_QUNSET_CALLBACK             FQUCBK
#define HF_SET_CALLBACK          FCBACK
#define HF_SHOW_CALLBACK           FSCBAK
#define HF_SHOW_NET_CALLBACK               FNCBAK
#define HF_SHOW_ONE_CALLBACK               FOCBAK
#define HF_SHOW_ONE_NET_CALLBACK                   FONCBK
#define HF_UNSET_CALLBACK            FUCBAK
#define HF_QUNSET_ONE_CALLBACK                 FQUOCB
#define HF_UNSET_ONE_CALLBACK                FUNOCB
#define HF_INCLUDE_SEGMENT_BY_KEY                    FISGBK
#define HF_KINCLUDE_SEGMENT_BY_KEY                     FKISBK
#define HF_STYLE_SEGMENT_BY_KEY                  FSSGBK
#define HF_KSTYLE_SEGMENT_BY_KEY                   FKSSBK
#define HF_SHOW_PARTIAL_MESH               FSHPMS
#define HF_INSERT_CUTTING_PLANE                  FICUTP
#define HF_KINSERT_CUTTING_PLANE                   FKCUTP
#define HF_QINSERT_CUTTING_PLANE                   FQCUTP
#define HF_QKINSERT_CUTTING_PLANE                    FQKCUT
#define HF_SHOW_CUTTING_PLANE                FSCUTP
#define HF_KSHOW_INCLUDE_SEGMENT                   FKSINC
#define HF_KSHOW_STYLE_SEGMENT                 FKSSTY
#define HF_KRENUMBER_KEY           FKRNKY
#define HF_SET_USER_OPTION_BY_INDEX                      FSUOBI
#define HF_QSET_USER_OPTION_BY_INDEX                       FQSUOI
#define HF_UNSET_USER_OPTION_BY_INDEX                        FUUOBI
#define HF_QUNSET_USER_OPTION_BY_INDEX                         FQUUOI
#define HF_DEFINE_FONT         FDEFNT
#define HF_DEFINE_FONT_BY_REFERENCE                      FDEFNR
#define HF_SHOW_FONT       FSHFNT
#define HF_SHOW_FONT_SIZE            FSHFNS
#define HF_UNDEFINE_FONT           FUDFNT
#define HF_SHOW_SYSTEM_INFO              FSSYFO

#endif

#define HF_DEFINED
#endif

