      subroutine setup(xmin,xmax,ymin,ymax,uout)
c
c=========================== Subroutine Setup =========================
c
c     implicit real(a-h,o-z)
      double precision xmin, xmax, ymin, ymax
      integer iout

      integer ixmin, ixmax, iymin, iymax
      double precision xw, yw
      double precision aspec, qx, qy
c
c----Plot10 calls to set up terminal 
c
      call init(1200,4010,ixmin,ixmax,iymin,iymax,iout)
      aspec = float(iymax-iymin)/float(ixmax-ixmin)
      qx=aspec*(xmax-xmin)
      qy=(ymax-ymin)
      if (qx.gt.qy)then
        ymax=ymin + aspec*(xmax-xmin)
      else
        xmax=xmin+(ymax-ymin)/aspec
      endif
      xw=xmax-xmin
      yw=ymax-ymin
      call dwindo(sngl(xmin-xw/10.),sngl(xmax+xw/10.),
     +            sngl(ymin-yw/10.),sngl(ymax+yw/10.))

      call update_winparam(xmin, xmax, ymin, ymax)
      factor=1.5
      cxs=factor*xw/80.
      cys=factor*yw/50.
      return
      end

*---------------------------------------------------------------------
      subroutine update_winparam(minx, maxx, miny, maxy)
*---------------------------------------------------------------------
*     Update the window definition parameters.
*
*     (xwmin, ywmin)-(xwmax, ywmax): Window main diagonal.
*     length_win_diag: Length of the window main diagonal.
*
*     Author: Rodrigo A. Marin
*     Date  : January 30 1993
*---------------------------------------------------------------------

      include 'postcom.f'
      include 'pubfunc.h'

      double precision minx, maxx, miny, maxy

      xwmin = minx
      ywmin = miny
      xwmax = maxx
      ywmax = maxy

      length_win_diag = sqrt((xwmax - xwmin)**2 + (ywmax - ywmin)**2)

      return
      end
